"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.raw = void 0;
const file_loader_1 = __importDefault(require("file-loader"));
const loader_utils_1 = __importDefault(require("loader-utils"));
const replace_ext_1 = __importDefault(require("replace-ext"));
const schema_utils_1 = require("schema-utils");
const sharp_1 = __importDefault(require("sharp"));
const options_json_1 = __importDefault(require("./options.json"));
exports.raw = true;
function default_1(content, sourceMap) {
    const callback = this.async();
    const defaultOptions = {
        toBuffer: true,
    };
    const options = {
        ...defaultOptions,
        ...loader_utils_1.default.getOptions(this),
    };
    schema_utils_1.validate(options_json_1.default, options, {
        name: "Sharp Loader",
        baseDataPath: "options",
    });
    const returnedSharpObject = options.processFunction(sharp_1.default(Buffer.from(content)));
    if (!returnedSharpObject ||
        typeof returnedSharpObject.toBuffer !== "function")
        throw new Error("processFunction must return a sharp object");
    returnedSharpObject
        .toBuffer({ resolveWithObject: true })
        .then(({ data, info }) => {
        if (options.toBuffer)
            return callback(null, data);
        const fileLoaderContext = {
            ...this,
            resourcePath: replace_ext_1.default(this.resourcePath, `.${info.format}`),
            query: options.fileLoaderOptions,
        };
        const fileLoaderResult = file_loader_1.default.call(fileLoaderContext, data, sourceMap);
        return callback(null, fileLoaderResult);
    })
        .catch((e) => {
        throw e;
    });
}
exports.default = default_1;
//# sourceMappingURL=index.js.map